# -*- coding: utf-8 -*-
"""
Created on Tue Oct  2 09:54:34 2018

@author: JinZhu
"""

import os
if os.path.exists("nilearn_cache"):
    os.remove("nilearn_cache")

import numpy as np
sample_list = [x for x in os.listdir() if os.path.isdir(x)]

from nilearn import datasets
atlas = datasets.fetch_atlas_aal(version='SPM12', data_dir=None, url=None, resume=True)
atlas_filename = atlas.maps
labels = atlas.labels

from nilearn.input_data import NiftiLabelsMasker
masker = NiftiLabelsMasker(labels_img=atlas_filename, standardize=True,
                           memory='nilearn_cache', verbose=5, 
                           resampling_target='labels')

from nilearn.connectome import ConnectivityMeasure
correlation_measure = ConnectivityMeasure(kind='correlation')

for sample in sample_list:
    rest_path1 = "./{}/func_1/rest.nii.gz".format(sample)
    time_series1 = masker.fit_transform(rest_path1)
    correlation_matrix1 = correlation_measure.fit_transform([time_series1])[0]
    #
    rest_path2= "./{}/func_2/rest.nii.gz".format(sample)
    time_series2 = masker.fit_transform(rest_path2)
    correlation_matrix2 = correlation_measure.fit_transform([time_series2])[0]
    #
    rest_path3 = "./{}/func_3/rest.nii.gz".format(sample)
    time_series3 = masker.fit_transform(rest_path3)
    correlation_matrix3 = correlation_measure.fit_transform([time_series3])[0]
    #
    correlation_matrix = correlation_matrix1 + correlation_matrix2 + correlation_matrix3
    correlation_matrix = correlation_matrix / 3.0
    np.savetxt("./{}/cor_mat.csv".format(sample), correlation_matrix, delimiter=",")